3 # Copyright (c) 2005, Linus Torvalds
4 # Copyright (c) 2005, Junio C Hamano
6 # Clone a repository into a different directory that does not yet exist.
8 # See git-sh-setup why.
17 die "Usage: $0 [--template=<template_directory>] [--reference <reference-repo>] [--bare] [-l [-s]] [-q] [-u <upload-pack>] [--origin <name>] [--depth <n>] [-n] <repo> [<dir>]"
23 cd "$1" || cd "$1.git" &&
31 if [ -n "$GIT_SSL_NO_VERIFY" ]; then
36 # $1 = Remote, $2 = Local
37 curl -nsfL $curl_extra_args "$1" >"$2"
41 # $1 - remote, $2 - local
43 clone_tmp="$GIT_DIR/clone-tmp" &&
44 mkdir -p "$clone_tmp" || exit 1
45 if [ -n "$GIT_CURL_FTP_NO_EPSV" -o \
46 "`git config --bool http.noEPSV`" = true ]; then
47 curl_extra_args="${curl_extra_args} --disable-epsv"
49 http_fetch "$1/info/refs" "$clone_tmp/refs" ||
50 die "Cannot get remote repository information.
51 Perhaps git-update-server-info needs to be run there?"
52 test "z$quiet" = z && v=-v || v=
53 while read sha1 refname
55 name=`expr "z$refname" : 'zrefs/\(.*\)'` &&
60 yes,* | ,heads/* | ,tags/*) ;;
63 if test -n "$use_separate_remote" &&
64 branch_name=`expr "z$name" : 'zheads/\(.*\)'`
66 tname="remotes/$origin/$branch_name"
70 git-http-fetch $v -a -w "$tname" "$sha1" "$1" || exit 1
71 done <"$clone_tmp/refs"
73 http_fetch "$1/HEAD" "$GIT_DIR/REMOTE_HEAD" ||
74 rm -f "$GIT_DIR/REMOTE_HEAD"
75 if test -f "$GIT_DIR/REMOTE_HEAD"; then
76 head_sha1=`cat "$GIT_DIR/REMOTE_HEAD"`
81 git-http-fetch $v -a "$head_sha1" "$1" ||
82 rm -f "$GIT_DIR/REMOTE_HEAD"
90 use_local_hardlink=yes
102 test -t 1 || no_progress=--no-progress
106 *,-n|*,--no|*,--no-|*,--no-c|*,--no-ch|*,--no-che|*,--no-chec|\
107 *,--no-check|*,--no-checko|*,--no-checkou|*,--no-checkout)
109 *,--na|*,--nak|*,--nake|*,--naked|\
110 *,-b|*,--b|*,--ba|*,--bar|*,--bare) bare=yes ;;
111 *,-l|*,--l|*,--lo|*,--loc|*,--loca|*,--local)
112 use_local_hardlink=yes ;;
113 *,--no-h|*,--no-ha|*,--no-har|*,--no-hard|*,--no-hardl|\
114 *,--no-hardli|*,--no-hardlin|*,--no-hardlink|*,--no-hardlinks)
115 use_local_hardlink=no ;;
116 *,-s|*,--s|*,--sh|*,--sha|*,--shar|*,--share|*,--shared)
118 1,--template) usage ;;
120 shift; template="--template=$1" ;;
123 *,-q|*,--quiet) quiet=-q ;;
124 *,--use-separate-remote) ;;
125 *,--no-separate-remote)
126 die "clones are always made with separate-remote layout" ;;
127 1,--reference) usage ;;
129 shift; reference="$1" ;;
131 reference=`expr "z$1" : 'z--reference=\(.*\)'` ;;
132 *,-o|*,--or|*,--ori|*,--orig|*,--origi|*,--origin)
137 die "'$2' is not suitable for an origin name"
139 git check-ref-format "heads/$2" ||
140 die "'$2' is not suitable for a branch name"
141 test -z "$origin_override" ||
142 die "Do not give more than one --origin options."
146 1,-u|1,--upload-pack) usage ;;
147 *,-u|*,--upload-pack)
149 upload_pack="--upload-pack=$1" ;;
151 upload_pack=--upload-pack=$(expr "z$1" : 'z-[^=]*=\(.*\)') ;;
165 die 'you must specify a repository to clone.'
167 # --bare implies --no-checkout and --no-separate-remote
168 if test yes = "$bare"
170 if test yes = "$origin_override"
172 die '--bare and --origin $origin options are incompatible.'
183 # Turn the source into an absolute path if
185 if base=$(get_repo_base "$repo"); then
191 # Try using "humanish" part of source repo if user didn't specify one
192 [ -z "$dir" ] && dir=$(echo "$repo" | sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
193 [ -e "$dir" ] && die "destination directory '$dir' already exists."
194 [ yes = "$bare" ] && unset GIT_WORK_TREE
195 [ -n "$GIT_WORK_TREE" ] && [ -e "$GIT_WORK_TREE" ] &&
196 die "working tree '$GIT_WORK_TREE' already exists."
201 test -z "$D" && rm -rf "$dir"
202 test -z "$W" && test -n "$GIT_WORK_TREE" && rm -rf "$GIT_WORK_TREE"
204 test -n "$D" && rm -rf "$D"
205 test -n "$W" && rm -rf "$W"
209 mkdir -p "$dir" && D=$(cd "$dir" && pwd) || usage
210 test -n "$GIT_WORK_TREE" && mkdir -p "$GIT_WORK_TREE" &&
211 W=$(cd "$GIT_WORK_TREE" && pwd) && export GIT_WORK_TREE="$W"
212 if test yes = "$bare" || test -n "$GIT_WORK_TREE"; then
218 git-init $quiet ${template+"$template"} || usage
220 if test -n "$reference"
223 if test -d "$reference"
225 if test -d "$reference/.git/objects"
227 ref_git="$reference/.git"
228 elif test -d "$reference/objects"
233 if test -n "$ref_git"
235 ref_git=$(cd "$ref_git" && pwd)
236 echo "$ref_git/objects" >"$GIT_DIR/objects/info/alternates"
238 GIT_DIR="$ref_git" git for-each-ref \
239 --format='%(objectname) %(*objectname)'
244 git update-ref "refs/reference-tmp/$a" "$a"
246 git update-ref "refs/reference-tmp/$b" "$b"
249 die "reference repository '$reference' is not a local directory."
253 rm -f "$GIT_DIR/CLONE_HEAD"
255 # We do local magic only when the user tells us to.
258 ( cd "$repo/objects" ) ||
259 die "cannot chdir to local '$repo/objects'."
261 if test "$local_shared" = yes
263 mkdir -p "$GIT_DIR/objects/info"
264 echo "$repo/objects" >>"$GIT_DIR/objects/info/alternates"
267 if test "$use_local_hardlink" = yes
269 # See if we can hardlink and drop "l" if not.
270 sample_file=$(cd "$repo" && \
271 find objects -type f -print | sed -e 1q)
272 # objects directory should not be empty because
274 test -f "$repo/$sample_file" || exit
275 if ln "$repo/$sample_file" "$GIT_DIR/objects/sample" 2>/dev/null
277 rm -f "$GIT_DIR/objects/sample"
280 echo >&2 "Warning: -l asked but cannot hardlink to $repo"
284 find objects -depth -print | cpio -pumd$l "$GIT_DIR/" || exit 1
286 git-ls-remote "$repo" >"$GIT_DIR/CLONE_HEAD" || exit 1
293 *) die "shallow over rsync not supported" ;;
295 rsync $quiet -av --ignore-existing \
296 --exclude info "$repo/objects/" "$GIT_DIR/objects/" ||
298 # Look at objects/info/alternates for rsync -- http will
299 # support it natively and git native ones will do it on the
300 # remote end. Not having that file is not a crime.
301 rsync -q "$repo/objects/info/alternates" \
302 "$GIT_DIR/TMP_ALT" 2>/dev/null ||
303 rm -f "$GIT_DIR/TMP_ALT"
304 if test -f "$GIT_DIR/TMP_ALT"
307 . git-parse-remote &&
308 resolve_alternates "$repo" <"$GIT_DIR/TMP_ALT" ) |
311 case "$alt" in 'bad alternate: '*) die "$alt";; esac
313 '') echo >&2 "Getting alternate: $alt" ;;
315 rsync $quiet -av --ignore-existing \
316 --exclude info "$alt" "$GIT_DIR/objects" || exit
318 rm -f "$GIT_DIR/TMP_ALT"
320 git-ls-remote "$repo" >"$GIT_DIR/CLONE_HEAD" || exit 1
322 https://*|http://*|ftp://*)
325 *) die "shallow over http or ftp not supported" ;;
327 if test -z "@@NO_CURL@@"
329 clone_dumb_http "$repo" "$D"
331 die "http transport not supported, rebuild Git with curl support"
335 case "$upload_pack" in
336 '') git-fetch-pack --all -k $quiet $depth $no_progress "$repo";;
337 *) git-fetch-pack --all -k $quiet "$upload_pack" $depth $no_progress "$repo" ;;
338 esac >"$GIT_DIR/CLONE_HEAD" ||
339 die "fetch-pack from '$repo' failed."
344 test -d "$GIT_DIR/refs/reference-tmp" && rm -fr "$GIT_DIR/refs/reference-tmp"
346 if test -f "$GIT_DIR/CLONE_HEAD"
348 # Read git-fetch-pack -k output and store the remote branches.
349 if [ -n "$use_separate_remote" ]
351 branch_top="remotes/$origin"
362 destname="REMOTE_HEAD" ;;
364 destname="refs/$branch_top/${name#refs/heads/}" ;;
366 destname="refs/$tag_top/${name#refs/tags/}" ;;
370 git update-ref -m "clone: from $repo" "$destname" "$sha1" ""
371 done < "$GIT_DIR/CLONE_HEAD"
374 if test -n "$W"; then
380 if test -z "$bare" && test -f "$GIT_DIR/REMOTE_HEAD"
382 # a non-bare repository is always in separate-remote layout
383 remote_top="refs/remotes/$origin"
384 head_sha1=`cat "$GIT_DIR/REMOTE_HEAD"`
387 # Uh-oh, the remote told us (http transport done against
388 # new style repository with a symref HEAD).
389 # Ideally we should skip the guesswork but for now
390 # opt for minimum change.
391 head_sha1=`expr "z$head_sha1" : 'zref: refs/heads/\(.*\)'`
392 head_sha1=`cat "$GIT_DIR/$remote_top/$head_sha1"`
396 # The name under $remote_top the remote HEAD seems to point at.
399 test -f "$GIT_DIR/$remote_top/master" && echo "master"
400 cd "$GIT_DIR/$remote_top" &&
401 find . -type f -print | sed -e 's/^\.\///'
406 test t = $done && continue
407 branch_tip=`cat "$GIT_DIR/$remote_top/$name"`
408 if test "$head_sha1" = "$branch_tip"
418 git config remote."$origin".url "$repo" &&
420 # Set up the mappings to track the remote branches.
421 git config remote."$origin".fetch \
422 "+refs/heads/*:$remote_top/*" '^$' &&
424 # Write out remote.$origin config, and update our "$head_points_at".
425 case "$head_points_at" in
427 # Local default branch
428 git symbolic-ref HEAD "refs/heads/$head_points_at" &&
430 # Tracking branch for the primary branch at the remote.
431 git update-ref HEAD "$head_sha1" &&
433 rm -f "refs/remotes/$origin/HEAD"
434 git symbolic-ref "refs/remotes/$origin/HEAD" \
435 "refs/remotes/$origin/$head_points_at" &&
437 git config branch."$head_points_at".remote "$origin" &&
438 git config branch."$head_points_at".merge "refs/heads/$head_points_at"
441 # Source had detached HEAD pointing nowhere
442 git update-ref --no-deref HEAD "$head_sha1" &&
443 rm -f "refs/remotes/$origin/HEAD"
447 case "$no_checkout" in
449 test "z$quiet" = z -a "z$no_progress" = z && v=-v || v=
450 git read-tree -m -u $v HEAD HEAD
453 rm -f "$GIT_DIR/CLONE_HEAD" "$GIT_DIR/REMOTE_HEAD"